<?php
/********************************** misc function ************************/

function true_var($v,$type=1){ // if value has only a word symbols

 switch($type){
   case 1:
     $vv = preg_replace("/[^\w\d\-_]/","",$v);
      break;
   case 2:
     $vv = preg_replace("/[^\w\040,\/\+\-]/","",$v);
      break;
   case 3:
     $vv = preg_replace("/[^\w\040]/","",$v);
      break;
 }
  if ($vv != $v or !$v){
     return false;
  }else{
    return true;
  }
}

function strip_slashes ($str){

  $str = is_array($str) ? array_map("strip_slashes",$str):stripslashes($str);
  return $str;
}
function add_slashes ($str){

  $str = is_array($str) ? array_map("add_slashes",$str):addslashes($str);
  return $str;
}

function html_entities ($str){

  $str = is_array($str) ? array_map("html_entities",$str):htmlentities($str);
  return $str;
}


function replace_br($str){
  $str = preg_replace ("/(\r\n|\r|\n)/","<br />",$str);
  return $str;
}
function clear_string($str){

 $str = trim(preg_replace("/[^\w\d\040]/","",$str));
 return $str;
}

function get_code($len=6){

   $code = strtoupper(substr(md5(rand (1,1000)),0,$len));
   return $code;
}


/********************************** image function ************************/

function get_image ($path,$type){ // get image by type

    switch($type){
        case '1':
         $img['stream'] = imagecreatefromgif($path);
         $img['ext'] = "gif";
         break;
        case '2':
         $img['stream'] = imagecreatefromjpeg($path);
         $img['ext'] = "jpg";
         break;
        case '3':
         $img['stream'] = imagecreatefrompng($path);
         $img['ext'] = "png";
         break;
    }

    return $img;
}

function image_resize($img, $maxw,$maxh) { //

        $imgX = ImageSX($img);
        $imgY = ImageSY($img);

     if (($imgX >$maxw and $maxw>0) or ($imgY >$maxh and $maxh>0)){ // don't resize if picture less then $maxw or $maxh

        if (!$maxh){
             $maxh = round(($maxw * $imgY)/$imgX);
        }elseif (!$maxw){
             $maxw = round(($maxh * $imgX)/$imgY);
        }

        $image = ImageCreateTrueColor($maxw, $maxh);
        ImageCopyResampled($image, $img, 0, 0, 0, 0, $maxw, $maxh, $imgX, $imgY);

        return $image;
     }else{

        return $img;
     }
}

function save_image($src,$dst_path,$ext){ // save resized image

         $dst = $dst_path.".".$ext;

         switch ($ext){
            case 'gif':
               imagegif($src,$dst);
             break;
            case 'jpg':
               imagejpeg($src,$dst);
             break;
            case 'png':
               imagepng($src,$dst);
             break;
         }
}

function check_image($pid,$type="t",$url=1,$key=false,$folder=NEWS_PICS){ //  url = 2 for http picture path // 1 - drive root path

    if ($key) $pid = $pid[$key];

    $thumb_path =   CORE_ROOT.$folder.($type?$type."_":"").md5($pid);
    if ($url ==2) $hpath = HOST_PATH.$folder.$type."_".md5($pid);

    if (file_exists($thumb_path.".gif")){
        $ext = ".gif";
    }elseif(file_exists($thumb_path.".jpg")){
        $ext = ".jpg";
    }elseif(file_exists($thumb_path.".png")){
        $ext = ".png";
    }

    if ($ext){
       return  $url==2 ? $hpath.$ext: $thumb_path.$ext ;
    }else{
      return false;
    }
}

/********************************** xxxxxxxxxxx ************************/

function check_email($email){ // check email address

   if (trim($email)){
       preg_match ("/^(([A-Za-z0-9]+_+)|([A-Za-z0-9]+\-+)|([A-Za-z0-9]+\.+)|([A-Za-z0-9]+\++))*[A-Za-z0-9]+@((\w+\-+)|(\w+\.))*\w{1,63}\.[a-zA-Z]{2,6}/mis",$email,$match);
      if ($match[0] !=$email){
        return false;
      }else{
       return true;
      }
   }else{
      return false;
   }
}
function sendmail($nameto,$mailto,$namefrom,$mailfrom,$subject,$message,$type="text/html"){

         $mailheader = "MIME-Version: 1.0\r\n";
         $mailheader .= "Content-type: ".$type."; charset=iso-8859-1\r\n";
         $mailheader .= "To:  <".$mailto."> \r\n";
         $mailheader .= "From: ".$namefrom."  <".$mailfrom.">\r\n";
         $mailheader .= "Reply-To: ".$mailfrom."\r\n";

//       echo "<hr>mailto=<br>",$mailto,"<hr>subject=<br>",$subject,"<hr>message=<br>",$message,"<hr>mailheader=<br>",$mailheader,"<hr>";

        $send = @mail ($mailto,$subject,$message,$mailheader);
        return $send;
}

function get_date ($time=""){ //  drop down items with data / month / year lists

     if (!$time) $time = time();
     $today = getdate($time);

         for ($i=1;$i<32;$i++){ $date['day'][sprintf("%02d",$i)]="";}

         for ($i=1;$i<13;$i++){
           $m = date ("F",strtotime ($i."/01/2000"));
           $date['month'][$m]="";
         }
         for ($i=2005;$i<2015;$i++){  $date['year'][$i]="";}

         $date['day'][sprintf("%02d",$today['mday'])]="selected=\"selected\"";
         $date['month'][$today['month']]="selected=\"selected\"";
         $date['year'][$today['year']]="selected=\"selected\"";

         return $date;

}

// page_href = http://... link &amp;p=  $p_type = 1 if links without prev /next
function paging($row_count,$page_href,$curpage, $limitperpage=10,$p_type="",$ignore_rewrite=false,$pagevar="page"){

global $mod_rewrite_urls;

   if ($mod_rewrite_urls and !$ignore_rewrite){
        $page_l = "<a href='%s/' class=\"link\">%s</a>";
         $pagevar = "/page";
   }else{
         $pagevar = "&amp;page=";
         $page_l = "<a href='%s' class=\"link\">%s</a>";
   }
         $page_c = "[%s]"; // current page
         $page_separator = " , ";
         $page_stop = "&nbsp;&nbsp;&nbsp;";
         $page_start = "";
         $next_page ="%s";
         $previous_page = "%s";
         $maxmiddle = 10;


            if ($row_count >0){
                     $page_count = floor($row_count/$limitperpage);
                     $page_total = ceil($row_count/$limitperpage);
                     $page_last  = $row_count - $page_count*$limitperpage;

                      $page_begin = ($curpage ==0) ? "%s": sprintf($page_l,($page_href.(($curpage-1)? $pagevar.($curpage-1):"")),$previous_page);
                      $page_end = ($curpage == ($page_total-1)) ? "%s" : sprintf($page_l,($page_href.$pagevar.($curpage+1)),$next_page);

                     for ($i=0;$i<$page_count;$i++){

                           if($curpage==$i){
                              $page_middle[] = sprintf($page_c,($i+1));
                          }else{
                              $xx = $i+1;
                              $page_middle[] = sprintf($page_l,($page_href.($i? $pagevar.$i:"")),$xx);
                          }
                     }
                     $i= count($page_middle);
                     if ($page_total !=$page_count){ // link before Next

                          if($curpage==$i){
                                 $page_middle[] = sprintf($page_c,($i+1));
                          }else{
                              $xx = $i+1;
                              $page_middle[] = sprintf($page_l,($page_href.($i? $pagevar.$i:"")),$xx);
                          }
                     }
                     if (count($page_middle)>$maxmiddle) {

                         if (($curpage+1) >= $maxmiddle and count($page_middle)-$curpage>=$maxmiddle){
                            $sl_st = $curpage - floor($maxmiddle/2);
                            $page_middle = array_slice($page_middle,$sl_st,$maxmiddle);
                         }elseif(count($page_middle)-$curpage <$maxmiddle){
                            $page_middle = array_slice($page_middle,-1*$maxmiddle);
                         }else{
                            $page_middle = array_slice($page_middle,0,$maxmiddle);
                         }

                     }

                   if ($p_type){
                     $page_link = join($page_separator,$page_middle);
                   }else{
                     $page_link = $page_begin.$page_stop.$m_beg.join($page_separator,$page_middle).$page_stop.$m_end.$page_start.$page_end;
                   }
              }

  return $page_link;
}

/********************************** news function ************************/

function get_news ($per_page,$limit_from=0,$pages=1,$page_href="",$active=0,$short_pages=""){ // get list of news

  global $sm, $my, $date_format,$rq;

  if ($active == 1 ){ // select active news only
       $w_clause[] = " n.active ='1' ";
  }elseif($active == 2){ // non active news
       $w_clause[] = " n.active ='' ";
  } // all news

  if (is_numeric($rq['c'])) $w_clause[] = " n.cid='".$rq['c']."' "; /// show news for selected category only

  if (is_array($w_clause)) $w_clause = " where ".join ("and",$w_clause);

  $res = $my->my_query ("select n.*,c.cname from ".TBL_PF."news as n
                           left join ".TBL_PF."categories as c
                           on c.cid=n.cid
                         $w_clause
                         order by n.postdate desc
                         limit $limit_from,$per_page");

   while ($row = mysql_fetch_assoc($res)){

       $row['postdate'] = date($date_format,$row['postdate']);

       // get news pictures
       $thumb = $my->get_line ("select pid from ".TBL_PF."newspics where nid='".$row['nid']."' and pictype='prim' limit 0,1");

       if ($thumb['pid']) $row['img'] = check_image($thumb['pid'],"t",2);
       $news[] = $row;
   }

  if ($pages){
        $cnt = $my->get_line("select count(n.nid) from ".TBL_PF."news as n $w_clause","k");

        if ($short_pages){ // show paging without prev / next and with first active link
//            $per_page = $type_all;
//            $rq['page'] = 0;
         if ($cnt>$per_page){

                   $paging['total'] = ceil($cnt/$per_page);

                   $paging['prev'] = ($rq['page']-1)>0 ? $rq['page']-1 : "";

                   $paging['next'] = ($rq['page']+1 < $paging['total'] )?$rq['page']+1 : ($paging['total']-1) ;
                   $paging['last'] = $paging['total']-1;
                   $paging['current'] = $rq['page']+1;
                   $paging['cid'] = $rq['c'];
         }

          $sm->assign("paging",$paging);

        }elseif ($cnt>$per_page) {
          $paging = paging($cnt,$page_href,$rq['page'],$per_page,"",true);
          $sm->assign("paging",$paging);
        }
  }
   return $news;
}

function get_cat_list ($active = false){ // list of news categories

   global $my;

   if ($active) $w_clause = " where n.active ='1'";

   $cats = $my->get_array("select c.*,count(n.nid) as ncnt from ".TBL_PF."categories as c
                          left join ".TBL_PF."news as n on c.cid=n.cid
                          $w_clause
                          group by c.cid
                          order by c.cname ");
   return $cats;
}

function translate_month($str){ // translate month / day from english to another ...

   $search = array("January","February","March","April","May","June","July","August","September","October","November","December","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday","Sunday");
   $replace = array("Januar","Februar","Mart","April","Maj","Jun","Jul","Avgust","Septembar","Oktobar","Novembar","Decembar","Ponedeljak","Utorak","Sreda","Cetvrtak","Petak","Subota","Nedelja");

   $str = str_replace ($search,$replace,$str);
   return $str;
}
function redirect ($url=""){

  header ("Location: ".HOST_PATH.$url);
  die;

}

function convert_to_url($url,$misc=true,$addvars=""){

global $mod_rewrite_urls,$links;

   if ($mod_rewrite_urls){

      $url_parts =  parse_url($url);
      parse_str($url_parts['query'],$query);

/*      $url = $links[$query['a']]."/";
      unset ($query['a']);
      $url .= join("/",$query);*/

      foreach ($query as $key=>$value){

               if ($key == "a"){
                  $u[] = $links[$value]?$links[$value]:$value;

               }else{
                 $u[] = $key.$value;
               }
      }
      if ($u) $url = join ("/",$u).($misc?"/":"");
   }

   if ($mod_rewrite_urls and $addvars){
        $url .= "?".$addvars;
   }elseif($query and $addvars){
        $url .= (strstr($url,"?") ? "&amp;":"?").$addvars;
   }

    return htmlentities(HOST_PATH.$url);
}

function auth_user(&$sm){ // forum user authorization

 global $my,$priv;

  if (!$_SESSION['user_info'] and $_COOKIE['session_vars']){
       $_SESSION['user_info'] = unserialize(stripslashes(base64_decode($_COOKIE['session_vars'])));
       $update = true;
  }

  $user_info = $my->get_line("select * from ".TBL_PF."users where ustatus !='b' and uname='".$_SESSION['user_info']['uname']."' and upwd ='".$_SESSION['user_info']['upwd']."' limit 0,1");

  if ($update){
      $_SESSION['user_info']['ulastvisit'] = $user_info['ulastvisit'];
  }
      $_SESSION['user_info']['priv'] = $user_info['upriv'] == "ad" ? $priv : explode(",",$user_info['upriv']); // add all privilegies if logged as admin

  if ($user_info['uid']){

    $sm->assign("user_info",$user_info);
    $my->my_query("update ".TBL_PF."users set ulastvisit ='".correct_time_zone()."' where uid='".$user_info['uid']."'");

  }else{
     unset ($_SESSION['user_info']);
     unset ($_COOKIE['user_info']);
  }

  return $user_info;
}

function correct_time_zone($time="",$ord=true){

 global $forum_gmt;
 if (!$time) $time=time();

 if ($ord){ // system timezone
    $time = $time-$forum_gmt*3600;
 }else{ // user timezone
    $time = $time+$_SESSION['user_info']['ugmt']*3600;
 }

   return $time;
}

function change_position($item,$table,$key,$way="up",$akey=""){ // change position in forum order ........... // $akey - additional key for items ..... for group of index $key

  global $my;

   if ($akey) $a = $akey.", ";

    $cur_pos =$my->get_line("select $a position from ".TBL_PF.$table." where $key='$item' limit 0,1");

//print_R ($cur_pos);

   if ($way=="down"){
      $order = "position > ".$cur_pos['position']." order by position asc";
   }else{ // way = up
      $order = "position < ".$cur_pos['position']." order by position desc";
   }

   if ($akey) $ak =  " $akey='".$cur_pos[$akey]."' and ";

   $new_pos = $my->get_line("select $key,position from ".TBL_PF.$table." where $ak $order limit 0,1");

   if(!$new_pos['position']){
    $new_pos['position']=$cur_pos['position'];
    $new_pos[$key]=$item;
   }
   // set new position for selected item
   $my->my_query ("update ".TBL_PF.$table." set position='".$new_pos['position']."' where $key='$item'");
   $my->my_query ("update ".TBL_PF.$table." set position='".$cur_pos['position']."' where $key='".$new_pos[$key]."'");


}
function get_polls($pid=""){ // get active poll to smarty template ... or votes table

 global $my,$sm,$lang,$rq;

  $w_clause =  $pid?" pid='$pid'":"active='1' ";

  $polls = $my->get_line ("select * from ".TBL_PF."polls where $w_clause and parentid='0' limit 0,1");
  $polls['answer'] = $my->get_array ("select * from ".TBL_PF."polls where parentid='".$polls['pid']."' order by pid",array("pid","pname"));

  $vote = $my->get_line ("select vid from ".TBL_PF."votes where ip='".ip2long($_SERVER['REMOTE_ADDR'])."' and pid='".$polls['pid']."' limit 0,1");

  if ($vote['vid'] or is_numeric($pid)){ // voted user

      $votes = $my->get_array ("select aid, count(vid) as cnt from ".TBL_PF."votes where pid='".$polls['pid']."' group by aid",array("aid","cnt"));

      $votes_total = array_sum($votes);

      foreach ($polls['answer'] as $key=>$value){
         $polls['votes'][$key]['cnt'] = $votes[$key]?$votes[$key]:"0";
         $polls['votes'][$key]['perc'] = $votes_total? $votes[$key]/$votes_total*100 :0;
      }
  }
  $sm->assign("polls",$polls);
}

function download_categories ($parentid=0){

 global $my;

  $cats = $my->get_array("select * from  ".TBL_PF."dwn_categories where parentid='".$parentid."' order by cname asc");

        foreach ($cats as $key=>$value){

           if (!$parentid){
                $cats[$key]['sub'] = $my->get_array("select * from  ".TBL_PF."dwn_categories where parentid='".$value['cid']."' order by cname asc");
                foreach ($cats[$key]['sub'] as $kk => $vv){
                  $cats[$key]['sub'][$kk]['cnt'] = $my->get_line("select count(did) from ".TBL_PF."dwn_downloads where cid='".$vv['cid']."'","k");

                }
           }
           $cats[$key]['cnt'] = $my->get_line("select count(did) from ".TBL_PF."dwn_downloads where cid='".$value['cid']."'","k");
       }
  return $cats;
}

function update_downloads (&$arr,$key=0){

 global $date_format;

 $arr['ddate'] = date ($date_format,$arr['ddate']);

 if ($arr['dsize']) $arr['dsize'] = number_format($arr['dsize']/1024,2,","," ");
 if ($arr['ddescription']) $arr['ddescription'] = htmlentities($arr['ddescription']);

}
function update_reports (&$arr,$key=0){

 global $date_format,$my;

 $arr['rtime'] = date ($date_format,$arr['rtime']);
 $arr['rip'] = long2ip($arr['rip']);

 if ($arr['uid']) $arr['ruser'] = $my->get_line("select uname from ".TBL_PF."users where uid ='".$arr['uid']."' limit 0,1","k");
}
?>